Attribute VB_Name = "GlobalProcs"
Public fMainForm As frmMain


Sub Main()
    Set fMainForm = New frmMain
    fMainForm.Show
    Endl$ = Chr$(13) + Chr$(10)
    Scene.Zdist = 5
    Scene.Wdist = 5
    Scene.FOV = Pi / 2
    Preferences.Rangle = 2
    Preferences.StereoSep = 10
    If Command$ <> "" Then
        loadPoints (Command$)
    Else
        loadPoints (CurDir + "\hypercube.4d")
    End If
    Scene.T.X = 0
    Scene.T.Y = 0
    Scene.T.Z = 0
    Scene.T.W = 0
    
End Sub

Function SetPoint(X, Y, Z, W) As point
Dim pt As point
pt.X = X
pt.Y = Y
pt.Z = Z
pt.W = W
SetPoint = pt
End Function


Function loadPoints(fName)

Endl$ = Chr$(13) + Chr$(10)
ptStart$ = "["
ptEnd$ = "]"
ptSep$ = ","
cmntMark$ = "#"
lnStart$ = "("
lnEnd$ = ")"
lnSep$ = "-"

Set fso = CreateObject("Scripting.FileSystemObject")
If (fso.FileExists(fName)) Then
    Open fName For Binary As #1

    Dim strng$
    strng$ = Space$(LOF(1))
    Get #1, 1, strng$
    
    Close #1
Else
    MsgBox "File does not exist: " + fName
    Exit Function
End If

Dim lineIsComment As Boolean
Dim CurrAxis As Integer  '0 = next point; 1 = X; 4 = W; 6 = line1; 7 = line2
CurrAxis = 0
currPt = 1
NumPoints = 0
NumLines = 0
marker = 0
lineNum = 1
currln = 1

 
For i = 1 To Len(strng$)  'count the number of points and lines in the file
    If Mid$(strng$, i, 1) = cmntMark$ Then lineIsComment = True
    If Mid$(strng$, i, 2) = Endl$ Then lineIsComment = False
    If Mid$(strng$, i, 1) = ptStart$ And (Not lineIsComment) Then NumPoints = NumPoints + 1
    If Mid$(strng$, i, 1) = lnStart$ And (Not lineIsComment) Then NumLines = NumLines + 1
Next

If NumPoints < 1 Then
    MsgBox "File has no valid point data: " + fName
    fileLoaded = False
        
    Exit Function
End If

ReDim pointSet(NumPoints)
ReDim pointSetFinal1(NumPoints)
ReDim pointSetFinal2(NumPoints)
ReDim lineSet(NumLines)

For i = 1 To Len(strng$) 'read the data
    If currPt > NumPoints + 1 Or currln > NumLines + 1 Then
        Call inputError(lineNum, 1)
        Exit Function
    End If
                        'handle comment marks and crlf
    If Mid$(strng$, i, 1) = cmntMark$ Then lineIsComment = True
    If Mid$(strng$, i, 2) = Endl$ Then
        lineIsComment = False
        lineNum = lineNum + 1
    End If
    
    If Not lineIsComment Then  'parse actual data
    If Mid$(strng$, i, 1) = ptStart$ Then
        If CurrAxis <> 0 Then
            Call inputError(lineNum, 2)
            Exit Function
        End If
        CurrAxis = 1
        marker = i + 1
    ElseIf Mid$(strng$, i, 1) = ptEnd$ Then
        If CurrAxis = 0 Or CurrAxis = 5 Then
            Call inputError(lineNum, 3)
            Exit Function
        End If
        dummy = setData(CurrAxis, Val(Mid$(strng$, marker, i - (marker))), currPt)
        CurrAxis = 0
        currPt = currPt + 1
        
    ElseIf Mid$(strng$, i, 1) = ptSep$ Then
        If CurrAxis = 0 Or CurrAxis = 5 Then
            Call inputError(lineNum, 4)
            Exit Function
        End If
        dummy = setData(CurrAxis, Val(Mid$(strng$, marker, i - (marker))), currPt)
        CurrAxis = CurrAxis + 1
        marker = i + 1
    
    ElseIf Mid$(strng$, i, 1) = lnStart$ Then
        If CurrAxis <> 0 Then
            Call inputError(lineNum, 5)
            Exit Function
        End If
        CurrAxis = 6
        marker = i + 1
    ElseIf Mid$(strng$, i, 1) = lnSep$ And CurrAxis > 5 Then
        If CurrAxis <> 6 Then
            Call inputError(lineNum, 6)
            Exit Function
        End If
        lineSet(currln).X = Val(Mid$(strng$, marker, i - (marker)))
        CurrAxis = CurrAxis + 1
        marker = i + 1
    ElseIf Mid$(strng$, i, 1) = lnEnd$ Then
        If CurrAxis <> 7 Then
            Call inputError(lineNum, 7)
            Exit Function
        End If
        lineSet(currln).Y = Val(Mid$(strng$, marker, i - (marker)))
        CurrAxis = 0
        currln = currln + 1
        End If
    End If
Next

fMainForm.Caption = "4DViewer: " + fName

fileLoaded = True
Filename = fName
copyPoints
Draw
End Function


Function copyPoints()
ReDim pointSet2(NumPoints)
For i = 1 To NumPoints
    pointSet2(i) = SetPoint(pointSet(i).X, pointSet(i).Y, pointSet(i).Z, pointSet(i).W)
Next
ReDim pointSetFinal1(NumPoints)
ReDim pointSetFinal2(NumPoints)
End Function

Function inputError(lineNum, errNum)
ReDim pointSet(0)
ReDim lineSet(0)
NumLines = 0
NumPoints = 0
MsgBox ("Error " + Str$(errNum) + " in input file near line " + Str$(lineNum))
End Function

Function setData(Axis, data, currPt)
        Select Case Axis
            Case 1
                pointSet(currPt).X = data
            Case 2
                pointSet(currPt).Y = data
            Case 3
                pointSet(currPt).Z = data
            Case 4
                pointSet(currPt).W = data
            Case Else
                Call inputError(lineNum, 8)
                Exit Function
        End Select

End Function
